diff --git a/src/wrapped/wrappedlibc.c b/src/wrapped/wrappedlibc.c
index e8eda9b84a..980a0ffee8 100755
--- a/src/wrapped/wrappedlibc.c
+++ b/src/wrapped/wrappedlibc.c
@@ -1652,7 +1652,7 @@ EXPORT int32_t my_execv(x86emu_t* emu, const char* path, char* const argv[])
     int x86 = FileIsX86ELF(path);
     printf_log(LOG_DEBUG, "execv(\"%s\", %p) is x86=%d\n", path, argv, x86);
     #if 1
-    if (x86 || self) {
+    if ((x86 || self) && argv) {
         int skip_first = 0;
         if(strlen(path)>=strlen("wine-preloader") && strcmp(path+strlen(path)-strlen("wine-preloader"), "wine-preloader")==0)
             skip_first++;
@@ -1669,6 +1669,8 @@ EXPORT int32_t my_execv(x86emu_t* emu, const char* path, char* const argv[])
         return ret;
     }
     #endif
+    if(self && !argv)
+        return execv(emu->context->box86path, argv);
     return execv(path, argv);
 }
 
@@ -1678,7 +1680,7 @@ EXPORT int32_t my_execve(x86emu_t* emu, const char* path, char* const argv[], ch
     int x86 = FileIsX86ELF(path);
     printf_log(LOG_DEBUG, "execv(\"%s\", %p) is x86=%d\n", path, argv, x86);
     #if 1
-    if (x86 || self) {
+    if ((x86 || self) && argv) {
         int skip_first = 0;
         if(strlen(path)>=strlen("wine-preloader") && strcmp(path+strlen(path)-strlen("wine-preloader"), "wine-preloader")==0)
             skip_first++;
@@ -1695,6 +1697,8 @@ EXPORT int32_t my_execve(x86emu_t* emu, const char* path, char* const argv[], ch
         return ret;
     }
     #endif
+    if(self && !argv)
+        return execve(emu->context->box86path, argv, envp);
     return execve(path, argv, envp);
 }
 
@@ -1705,7 +1709,7 @@ EXPORT int32_t my_execvp(x86emu_t* emu, const char* path, char* const argv[])
     int self = (strcmp(path, "/proc/self/exe")==0)?1:0;
     int x86 = FileIsX86ELF(path);
     printf_log(LOG_DEBUG, "execvp(\"%s\", %p), IsX86=%d\n", path, argv, x86);
-    if (x86 || self) {
+    if ((x86 || self) && argv) {
         // count argv...
         int i=0;
         while(argv[i]) ++i;
@@ -1719,6 +1723,8 @@ EXPORT int32_t my_execvp(x86emu_t* emu, const char* path, char* const argv[])
         free(newargv);
         return ret;
     }
+    if(self && !argv)
+        return execvp(emu->context->box86path, argv);
     return execvp(path, argv);
 }
 
